www.cendio.com
Bug 4596 - HTML5: Redirect/link from agent machine to master
: HTML5: Redirect/link from agent machine to master
Status: CLOSED FIXED
: ThinLinc
Web Access
: 4.0.0
: PC Unknown
: P2 Normal
: 4.2.0
Assigned To:
:
:
: 4132
:
  Show dependency treegraph
 
Reported: 2013-04-16 09:14 by
Modified: 2014-05-12 16:11 (History)


Attachments


Note

You need to log in before you can comment on or make changes to this bug.


Description From cendio 2013-04-16 09:14:31
After starting the HTML5 client, you will end up on an URL such as:

https://agent2.example.com:1009/main/agent

If you, say, bookmark this page and later returns to it, you will currently get
the message:

 Please visit the login server instead. 

One idea is to improve this by providing a link to the master machine.
Unfortunately, this is very difficult: We do not have that hostname. We have
/vsmagent/master_hostname, but that's an internal IP/name. We would rather need
something like /vsmagent/agent_hostname of the master machine, but that
parameter might not be configured if the master machine is not running an agent
as well. 

Also, there's a possibility that you have a proxy or firewall between the
browser and the TL servers. This would make it impossible to deduce the name of
the master machine. 

So currently, I'm leaning towards WONTFIX for this bug.
------- Comment #1 From cendio 2013-07-19 13:02:35 -------
I think Pierre's suggestion sounds like a good solution, to have a configurable
parameter that contains the url to the login page which the administrator can
set. Such a solution would be useful for bug 4721 as well.
------- Comment #2 From cendio 2013-12-02 13:31:35 -------
Perhaps it is possible to pass the URL to the master - the same URL that was
used for the initial login - in a hidden variable? That would be the best
solution; this would handle proxies/firewalls etc as well.
------- Comment #3 From cendio 2013-12-02 13:32:27 -------
(In reply to comment #2)
> Perhaps it is possible to pass the URL to the master - the same URL that was
> used for the initial login - in a hidden variable? That would be the best
> solution; this would handle proxies/firewalls etc as well.

Meant for bug 4721.
------- Comment #4 From cendio 2013-12-02 13:38:19 -------
(In reply to comment #3)
> (In reply to comment #2)
> > Perhaps it is possible to pass the URL to the master - the same URL that was
> > used for the initial login - in a hidden variable? That would be the best
> > solution; this would handle proxies/firewalls etc as well.
> 
> Meant for bug 4721.

Actually, I believe we can handle this by including the original login URL in a
CGI parameter when redirecting to the agent:

--- templates/main/redirect.tmpl    (revision 28169)
+++ templates/main/redirect.tmpl    (arbetskopia)
@@ -70,7 +70,7 @@
 </style>

 <div id="container">
-  <form id="redirform" method="post" action="$targetserver/main/agent">
+  <form id="redirform" method="post"
action="$targetserver/main/agent?loginserver=https://orginal-login-server.example.com">
------- Comment #5 From cendio 2014-02-19 16:58:59 -------
Fixed with r28466, r28468, and r28469. Solved using the configuration paramater
method.

r28466 - added the functionality
r28468 - updated comments in webaccess.hconf
r28469 - documentation
------- Comment #6 From cendio 2014-03-19 08:04:38 -------
(In reply to comment #5)
> Fixed with r28466, r28468, and r28469. Solved using the configuration paramater
> method.
> 
> r28466 - added the functionality
> r28468 - updated comments in webaccess.hconf
> r28469 - documentation

Tested in a cluster using build 4290, works as expected.

However, the redirect page is very ugly compared to redirect page used in
#4721.

Could this layout be shared ?
------- Comment #7 From cendio 2014-03-19 11:33:07 -------
(In reply to comment #6)
> However, the redirect page is very ugly compared to redirect page used in
> #4721.
> 
> Could this layout be shared ?

Fixed in revision 28664.
------- Comment #8 From cendio 2014-03-20 07:58:12 -------
Looks better in general, even the main page got affected.

However, when an error string is displayed over the login form, the size is
changed in a strange way.
------- Comment #9 From cendio 2014-03-20 13:40:58 -------
(In reply to comment #8)
> However, when an error string is displayed over the login form, the size is
> changed in a strange way.

Fixed in revision 28694.
------- Comment #10 From cendio 2014-03-21 13:00:51 -------
There are still some issues with the change of stylesheet.
- Remove 10% top margin
- Respect a max width of form and scale in height
- Center h and v
------- Comment #11 From cendio 2014-03-25 16:39:39 -------
(In reply to comment #10)
> There are still some issues with the change of stylesheet.
> - Remove 10% top margin
> - Respect a max width of form and scale in height
> - Center h and v

Fixed in revision 28713, instead of vertically centering the form, a set 50px
top-margin was added.
------- Comment #12 From cendio 2014-03-26 11:02:27 -------
(In reply to comment #11)
> (In reply to comment #10)
> > There are still some issues with the change of stylesheet.
> > - Remove 10% top margin
> > - Respect a max width of form and scale in height
> > - Center h and v
> 
> Fixed in revision 28713, instead of vertically centering the form, a set 50px
> top-margin was added.

Everything looks good now with tlwebaccess pages, however there is some issue
with the width of "Your session has ended." page from noVnc, which has a
strange width and not centered horizontally.
------- Comment #13 From cendio 2014-03-27 14:08:07 -------
(In reply to comment #12)
> Everything looks good now with tlwebaccess pages, however there is some issue
> with the width of "Your session has ended." page from noVnc, which has a
> strange width and not centered horizontally.

Fixed in revision 28735.
------- Comment #14 From cendio 2014-03-27 14:15:20 -------
(In reply to comment #13)
> Fixed in revision 28735.

Had forgotten to commit the centering of the div - updated in revision 28736.
------- Comment #15 From cendio 2014-04-01 15:57:00 -------
(In reply to comment #14)
> (In reply to comment #13)
> > Fixed in revision 28735.
> 
> Had forgotten to commit the centering of the div - updated in revision 28736.

Tested using build 4310 and it does look good now.
------- Comment #16 From cendio 2014-05-09 10:32:42 -------
The display of "Download Server Certificate" link, offsets the ThinLinc logo on
the login form. Making the ui very unbalanced.
------- Comment #17 From cendio 2014-05-09 11:36:13 -------
(In reply to comment #16)
> The display of "Download Server Certificate" link, offsets the ThinLinc logo on
> the login form. Making the ui very unbalanced.

Fixed in 28959.
------- Comment #18 From cendio 2014-05-12 16:11:25 -------
(In reply to comment #17)
> (In reply to comment #16)
> > The display of "Download Server Certificate" link, offsets the ThinLinc logo on
> > the login form. Making the ui very unbalanced.
> 
> Fixed in 28959.

Verified using 4.2.0 rc1 server side. Looks good.